/*@HEADER
// ***********************************************************************
//
//       Ifpack: Object-Oriented Algebraic Preconditioner Package
//                 Copyright (2009) Sandia Corporation
//
// Under terms of Contract DE-AC04-94AL85000, there is a non-exclusive
// license for use of this work by or on behalf of the U.S. Government.
//
// This library is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as
// published by the Free Software Foundation; either version 2.1 of the
// License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA
// Questions? Contact Michael A. Heroux (maherou@sandia.gov)
//
// ***********************************************************************
//@HEADER
*/

#ifndef EUCLID_USER_INTERFAACE
#define EUCLID_USER_INTERFAACE

/* collection of everthing that should be included for user apps */

#include "Euclid_dh.h"
#include "SubdomainGraph_dh.h"
#include "Mat_dh.h"
#include "Factor_dh.h"
#include "MatGenFD.h"
#include "Vec_dh.h"
#include "Parser_dh.h"
#include "Mem_dh.h"
#include "Timer_dh.h"
#include "TimeLog_dh.h"
#include "guards_dh.h"
#include "krylov_dh.h"
#include "io_dh.h"
#include "mat_dh_private.h"

#endif
